using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using Exferia_Maestros.General;
using Exferia_General;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Aplicacion.Modelos_Hermes;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_EntityFramework;

namespace Exferia_Maestros._3_Vistas.Listados
{
    public class ABS_Listado_HRM_TarifasLineas_P_Cliente_AUX_2 : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_HRM_TarifasLineas_P_Cliente_AUX_2()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //ZonaCabecera
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_ZONA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.idZonaCabecera), nameof(HRM_ZonasCabecera), nameof(HRM_ZonasCabecera.id), nameof(HRM_ZonasCabecera.codigo), nameof(HRM_ZonasCabecera.descripcion), nameof(HRM_ZonasCabecera.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.ZonaCabecera), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.ZonaCabecera), "Zona", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_ZONA));

            //Soporte
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_SOPORTE = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.idSoporte), nameof(SGA_Soportes), nameof(SGA_Soportes.id), nameof(SGA_Soportes.codigo), nameof(SGA_Soportes.descripcion), nameof(SGA_Soportes.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.Soporte), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.Soporte), "Soporte", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_SOPORTE));

            //cantidad
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.cantidad), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.cantidad), "Cantidad", G_ENUM_TIPOSDATOS.DECIMAL, false, 100, true, true, true, false, "", null));

            //importe
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.importe), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.importe), "Importe", G_ENUM_TIPOSDATOS.DECIMAL, false, 100, true, true, true, false, "", null));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_HRM_TARIFALINEA);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_HRM_TARIFALINEA + "_" + nameof(P_Cliente) + "_AUX_2";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_HRM_TarifasLineas_Listado_Modelo.ZonaCabecera);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
